//------------------------------------------------------------------------------
// PySyntaxBindings2.cpp
// Generated Python bindings for syntax types
//
// SPDX-FileCopyrightText: Michael Popoloski
// SPDX-License-Identifier: MIT
//------------------------------------------------------------------------------
#include "pyslang.h"

#include "slang/syntax/AllSyntax.h"

void registerSyntaxNodes2(py::module_& m) {
    py::class_<LoopGenerateSyntax, MemberSyntax>(m, "LoopGenerateSyntax")
        .def_readwrite("keyword", &LoopGenerateSyntax::keyword)
        .def_readwrite("openParen", &LoopGenerateSyntax::openParen)
        .def_readwrite("genvar", &LoopGenerateSyntax::genvar)
        .def_readwrite("identifier", &LoopGenerateSyntax::identifier)
        .def_readwrite("equals", &LoopGenerateSyntax::equals)
        .def_readwrite("initialExpr", &LoopGenerateSyntax::initialExpr)
        .def_readwrite("semi1", &LoopGenerateSyntax::semi1)
        .def_readwrite("stopExpr", &LoopGenerateSyntax::stopExpr)
        .def_readwrite("semi2", &LoopGenerateSyntax::semi2)
        .def_readwrite("iterationExpr", &LoopGenerateSyntax::iterationExpr)
        .def_readwrite("closeParen", &LoopGenerateSyntax::closeParen)
        .def_readwrite("block", &LoopGenerateSyntax::block);

    py::class_<IfGenerateSyntax, MemberSyntax>(m, "IfGenerateSyntax")
        .def_readwrite("keyword", &IfGenerateSyntax::keyword)
        .def_readwrite("openParen", &IfGenerateSyntax::openParen)
        .def_readwrite("condition", &IfGenerateSyntax::condition)
        .def_readwrite("closeParen", &IfGenerateSyntax::closeParen)
        .def_readwrite("block", &IfGenerateSyntax::block)
        .def_readwrite("elseClause", &IfGenerateSyntax::elseClause);

    py::class_<CaseGenerateSyntax, MemberSyntax>(m, "CaseGenerateSyntax")
        .def_readwrite("keyword", &CaseGenerateSyntax::keyword)
        .def_readwrite("openParen", &CaseGenerateSyntax::openParen)
        .def_readwrite("condition", &CaseGenerateSyntax::condition)
        .def_readwrite("closeParen", &CaseGenerateSyntax::closeParen)
        .def_readwrite("items", &CaseGenerateSyntax::items)
        .def_readwrite("endCase", &CaseGenerateSyntax::endCase);

    py::class_<GenerateBlockSyntax, MemberSyntax>(m, "GenerateBlockSyntax")
        .def_readwrite("label", &GenerateBlockSyntax::label)
        .def_readwrite("begin", &GenerateBlockSyntax::begin)
        .def_readwrite("beginName", &GenerateBlockSyntax::beginName)
        .def_readwrite("members", &GenerateBlockSyntax::members)
        .def_readwrite("end", &GenerateBlockSyntax::end)
        .def_readwrite("endName", &GenerateBlockSyntax::endName);

    py::class_<DividerClauseSyntax, SyntaxNode>(m, "DividerClauseSyntax")
        .def_readwrite("divide", &DividerClauseSyntax::divide)
        .def_readwrite("value", &DividerClauseSyntax::value);

    py::class_<TimeUnitsDeclarationSyntax, MemberSyntax>(m, "TimeUnitsDeclarationSyntax")
        .def_readwrite("keyword", &TimeUnitsDeclarationSyntax::keyword)
        .def_readwrite("time", &TimeUnitsDeclarationSyntax::time)
        .def_readwrite("divider", &TimeUnitsDeclarationSyntax::divider)
        .def_readwrite("semi", &TimeUnitsDeclarationSyntax::semi);

    py::class_<PortConnectionSyntax, SyntaxNode>(m, "PortConnectionSyntax")
        .def_readwrite("attributes", &PortConnectionSyntax::attributes);

    py::class_<EmptyPortConnectionSyntax, PortConnectionSyntax>(m, "EmptyPortConnectionSyntax")
        .def_readwrite("placeholder", &EmptyPortConnectionSyntax::placeholder);

    py::class_<OrderedPortConnectionSyntax, PortConnectionSyntax>(m, "OrderedPortConnectionSyntax")
        .def_readwrite("expr", &OrderedPortConnectionSyntax::expr);

    py::class_<NamedPortConnectionSyntax, PortConnectionSyntax>(m, "NamedPortConnectionSyntax")
        .def_readwrite("dot", &NamedPortConnectionSyntax::dot)
        .def_readwrite("name", &NamedPortConnectionSyntax::name)
        .def_readwrite("openParen", &NamedPortConnectionSyntax::openParen)
        .def_readwrite("expr", &NamedPortConnectionSyntax::expr)
        .def_readwrite("closeParen", &NamedPortConnectionSyntax::closeParen);

    py::class_<WildcardPortConnectionSyntax, PortConnectionSyntax>(m, "WildcardPortConnectionSyntax")
        .def_readwrite("dot", &WildcardPortConnectionSyntax::dot)
        .def_readwrite("star", &WildcardPortConnectionSyntax::star);

    py::class_<InstanceNameSyntax, SyntaxNode>(m, "InstanceNameSyntax")
        .def_readwrite("name", &InstanceNameSyntax::name)
        .def_readwrite("dimensions", &InstanceNameSyntax::dimensions);

    py::class_<HierarchicalInstanceSyntax, SyntaxNode>(m, "HierarchicalInstanceSyntax")
        .def_readwrite("decl", &HierarchicalInstanceSyntax::decl)
        .def_readwrite("openParen", &HierarchicalInstanceSyntax::openParen)
        .def_readwrite("connections", &HierarchicalInstanceSyntax::connections)
        .def_readwrite("closeParen", &HierarchicalInstanceSyntax::closeParen);

    py::class_<HierarchyInstantiationSyntax, MemberSyntax>(m, "HierarchyInstantiationSyntax")
        .def_readwrite("type", &HierarchyInstantiationSyntax::type)
        .def_readwrite("parameters", &HierarchyInstantiationSyntax::parameters)
        .def_readwrite("instances", &HierarchyInstantiationSyntax::instances)
        .def_readwrite("semi", &HierarchyInstantiationSyntax::semi);

    py::class_<PrimitiveInstantiationSyntax, MemberSyntax>(m, "PrimitiveInstantiationSyntax")
        .def_readwrite("type", &PrimitiveInstantiationSyntax::type)
        .def_readwrite("strength", &PrimitiveInstantiationSyntax::strength)
        .def_readwrite("delay", &PrimitiveInstantiationSyntax::delay)
        .def_readwrite("instances", &PrimitiveInstantiationSyntax::instances)
        .def_readwrite("semi", &PrimitiveInstantiationSyntax::semi);

    py::class_<CheckerInstantiationSyntax, MemberSyntax>(m, "CheckerInstantiationSyntax")
        .def_readwrite("type", &CheckerInstantiationSyntax::type)
        .def_readwrite("parameters", &CheckerInstantiationSyntax::parameters)
        .def_readwrite("instances", &CheckerInstantiationSyntax::instances)
        .def_readwrite("semi", &CheckerInstantiationSyntax::semi);

    py::class_<CheckerInstanceStatementSyntax, StatementSyntax>(m, "CheckerInstanceStatementSyntax")
        .def_readwrite("instance", &CheckerInstanceStatementSyntax::instance);

    py::class_<BindTargetListSyntax, SyntaxNode>(m, "BindTargetListSyntax")
        .def_readwrite("colon", &BindTargetListSyntax::colon)
        .def_readwrite("targets", &BindTargetListSyntax::targets);

    py::class_<BindDirectiveSyntax, MemberSyntax>(m, "BindDirectiveSyntax")
        .def_readwrite("bind", &BindDirectiveSyntax::bind)
        .def_readwrite("target", &BindDirectiveSyntax::target)
        .def_readwrite("targetInstances", &BindDirectiveSyntax::targetInstances)
        .def_readwrite("instantiation", &BindDirectiveSyntax::instantiation);

    py::class_<ClassSpecifierSyntax, SyntaxNode>(m, "ClassSpecifierSyntax")
        .def_readwrite("colon", &ClassSpecifierSyntax::colon)
        .def_readwrite("keyword", &ClassSpecifierSyntax::keyword);

    py::class_<FunctionPrototypeSyntax, SyntaxNode>(m, "FunctionPrototypeSyntax")
        .def_readwrite("keyword", &FunctionPrototypeSyntax::keyword)
        .def_readwrite("specifiers", &FunctionPrototypeSyntax::specifiers)
        .def_readwrite("lifetime", &FunctionPrototypeSyntax::lifetime)
        .def_readwrite("returnType", &FunctionPrototypeSyntax::returnType)
        .def_readwrite("name", &FunctionPrototypeSyntax::name)
        .def_readwrite("portList", &FunctionPrototypeSyntax::portList);

    py::class_<FunctionDeclarationSyntax, MemberSyntax>(m, "FunctionDeclarationSyntax")
        .def_readwrite("prototype", &FunctionDeclarationSyntax::prototype)
        .def_readwrite("semi", &FunctionDeclarationSyntax::semi)
        .def_readwrite("items", &FunctionDeclarationSyntax::items)
        .def_readwrite("end", &FunctionDeclarationSyntax::end)
        .def_readwrite("endBlockName", &FunctionDeclarationSyntax::endBlockName);

    py::class_<EqualsAssertionArgClauseSyntax, SyntaxNode>(m, "EqualsAssertionArgClauseSyntax")
        .def_readwrite("equals", &EqualsAssertionArgClauseSyntax::equals)
        .def_readwrite("expr", &EqualsAssertionArgClauseSyntax::expr);

    py::class_<AssertionItemPortSyntax, SyntaxNode>(m, "AssertionItemPortSyntax")
        .def_readwrite("attributes", &AssertionItemPortSyntax::attributes)
        .def_readwrite("local", &AssertionItemPortSyntax::local)
        .def_readwrite("direction", &AssertionItemPortSyntax::direction)
        .def_readwrite("type", &AssertionItemPortSyntax::type)
        .def_readwrite("name", &AssertionItemPortSyntax::name)
        .def_readwrite("dimensions", &AssertionItemPortSyntax::dimensions)
        .def_readwrite("defaultValue", &AssertionItemPortSyntax::defaultValue);

    py::class_<AssertionItemPortListSyntax, SyntaxNode>(m, "AssertionItemPortListSyntax")
        .def_readwrite("openParen", &AssertionItemPortListSyntax::openParen)
        .def_readwrite("ports", &AssertionItemPortListSyntax::ports)
        .def_readwrite("closeParen", &AssertionItemPortListSyntax::closeParen);

    py::class_<LetDeclarationSyntax, MemberSyntax>(m, "LetDeclarationSyntax")
        .def_readwrite("let", &LetDeclarationSyntax::let)
        .def_readwrite("identifier", &LetDeclarationSyntax::identifier)
        .def_readwrite("portList", &LetDeclarationSyntax::portList)
        .def_readwrite("equals", &LetDeclarationSyntax::equals)
        .def_readwrite("expr", &LetDeclarationSyntax::expr)
        .def_readwrite("semi", &LetDeclarationSyntax::semi);

    py::class_<DefaultExtendsClauseArgSyntax, SyntaxNode>(m, "DefaultExtendsClauseArgSyntax")
        .def_readwrite("openParen", &DefaultExtendsClauseArgSyntax::openParen)
        .def_readwrite("defaultKeyword", &DefaultExtendsClauseArgSyntax::defaultKeyword)
        .def_readwrite("closeParen", &DefaultExtendsClauseArgSyntax::closeParen);

    py::class_<ExtendsClauseSyntax, SyntaxNode>(m, "ExtendsClauseSyntax")
        .def_readwrite("keyword", &ExtendsClauseSyntax::keyword)
        .def_readwrite("baseName", &ExtendsClauseSyntax::baseName)
        .def_readwrite("arguments", &ExtendsClauseSyntax::arguments)
        .def_readwrite("defaultedArg", &ExtendsClauseSyntax::defaultedArg);

    py::class_<ImplementsClauseSyntax, SyntaxNode>(m, "ImplementsClauseSyntax")
        .def_readwrite("keyword", &ImplementsClauseSyntax::keyword)
        .def_readwrite("interfaces", &ImplementsClauseSyntax::interfaces);

    py::class_<ClassDeclarationSyntax, MemberSyntax>(m, "ClassDeclarationSyntax")
        .def_readwrite("virtualOrInterface", &ClassDeclarationSyntax::virtualOrInterface)
        .def_readwrite("classKeyword", &ClassDeclarationSyntax::classKeyword)
        .def_readwrite("finalSpecifier", &ClassDeclarationSyntax::finalSpecifier)
        .def_readwrite("name", &ClassDeclarationSyntax::name)
        .def_readwrite("parameters", &ClassDeclarationSyntax::parameters)
        .def_readwrite("extendsClause", &ClassDeclarationSyntax::extendsClause)
        .def_readwrite("implementsClause", &ClassDeclarationSyntax::implementsClause)
        .def_readwrite("semi", &ClassDeclarationSyntax::semi)
        .def_readwrite("items", &ClassDeclarationSyntax::items)
        .def_readwrite("endClass", &ClassDeclarationSyntax::endClass)
        .def_readwrite("endBlockName", &ClassDeclarationSyntax::endBlockName);

    py::class_<ClassPropertyDeclarationSyntax, MemberSyntax>(m, "ClassPropertyDeclarationSyntax")
        .def_readwrite("qualifiers", &ClassPropertyDeclarationSyntax::qualifiers)
        .def_readwrite("declaration", &ClassPropertyDeclarationSyntax::declaration);

    py::class_<ClassMethodDeclarationSyntax, MemberSyntax>(m, "ClassMethodDeclarationSyntax")
        .def_readwrite("qualifiers", &ClassMethodDeclarationSyntax::qualifiers)
        .def_readwrite("declaration", &ClassMethodDeclarationSyntax::declaration);

    py::class_<ClassMethodPrototypeSyntax, MemberSyntax>(m, "ClassMethodPrototypeSyntax")
        .def_readwrite("qualifiers", &ClassMethodPrototypeSyntax::qualifiers)
        .def_readwrite("prototype", &ClassMethodPrototypeSyntax::prototype)
        .def_readwrite("semi", &ClassMethodPrototypeSyntax::semi);

    py::class_<ContinuousAssignSyntax, MemberSyntax>(m, "ContinuousAssignSyntax")
        .def_readwrite("assign", &ContinuousAssignSyntax::assign)
        .def_readwrite("strength", &ContinuousAssignSyntax::strength)
        .def_readwrite("delay", &ContinuousAssignSyntax::delay)
        .def_readwrite("assignments", &ContinuousAssignSyntax::assignments)
        .def_readwrite("semi", &ContinuousAssignSyntax::semi);

    py::class_<DefParamAssignmentSyntax, SyntaxNode>(m, "DefParamAssignmentSyntax")
        .def_readwrite("name", &DefParamAssignmentSyntax::name)
        .def_readwrite("setter", &DefParamAssignmentSyntax::setter);

    py::class_<DefParamSyntax, MemberSyntax>(m, "DefParamSyntax")
        .def_readwrite("defparam", &DefParamSyntax::defparam)
        .def_readwrite("assignments", &DefParamSyntax::assignments)
        .def_readwrite("semi", &DefParamSyntax::semi);

    py::class_<ModportClockingPortSyntax, MemberSyntax>(m, "ModportClockingPortSyntax")
        .def_readwrite("clocking", &ModportClockingPortSyntax::clocking)
        .def_readwrite("name", &ModportClockingPortSyntax::name);

    py::class_<ModportPortSyntax, SyntaxNode>(m, "ModportPortSyntax");

    py::class_<ModportNamedPortSyntax, ModportPortSyntax>(m, "ModportNamedPortSyntax")
        .def_readwrite("name", &ModportNamedPortSyntax::name);

    py::class_<ModportExplicitPortSyntax, ModportPortSyntax>(m, "ModportExplicitPortSyntax")
        .def_readwrite("dot", &ModportExplicitPortSyntax::dot)
        .def_readwrite("name", &ModportExplicitPortSyntax::name)
        .def_readwrite("openParen", &ModportExplicitPortSyntax::openParen)
        .def_readwrite("expr", &ModportExplicitPortSyntax::expr)
        .def_readwrite("closeParen", &ModportExplicitPortSyntax::closeParen);

    py::class_<ModportSimplePortListSyntax, MemberSyntax>(m, "ModportSimplePortListSyntax")
        .def_readwrite("direction", &ModportSimplePortListSyntax::direction)
        .def_readwrite("ports", &ModportSimplePortListSyntax::ports);

    py::class_<ModportSubroutinePortSyntax, ModportPortSyntax>(m, "ModportSubroutinePortSyntax")
        .def_readwrite("prototype", &ModportSubroutinePortSyntax::prototype);

    py::class_<ModportSubroutinePortListSyntax, MemberSyntax>(m, "ModportSubroutinePortListSyntax")
        .def_readwrite("importExport", &ModportSubroutinePortListSyntax::importExport)
        .def_readwrite("ports", &ModportSubroutinePortListSyntax::ports);

    py::class_<ModportItemSyntax, SyntaxNode>(m, "ModportItemSyntax")
        .def_readwrite("name", &ModportItemSyntax::name)
        .def_readwrite("ports", &ModportItemSyntax::ports);

    py::class_<ModportDeclarationSyntax, MemberSyntax>(m, "ModportDeclarationSyntax")
        .def_readwrite("keyword", &ModportDeclarationSyntax::keyword)
        .def_readwrite("items", &ModportDeclarationSyntax::items)
        .def_readwrite("semi", &ModportDeclarationSyntax::semi);

    py::class_<ClockingSkewSyntax, SyntaxNode>(m, "ClockingSkewSyntax")
        .def_readwrite("edge", &ClockingSkewSyntax::edge)
        .def_readwrite("delay", &ClockingSkewSyntax::delay);

    py::class_<ClockingDirectionSyntax, SyntaxNode>(m, "ClockingDirectionSyntax")
        .def_readwrite("input", &ClockingDirectionSyntax::input)
        .def_readwrite("inputSkew", &ClockingDirectionSyntax::inputSkew)
        .def_readwrite("output", &ClockingDirectionSyntax::output)
        .def_readwrite("outputSkew", &ClockingDirectionSyntax::outputSkew);

    py::class_<DefaultSkewItemSyntax, MemberSyntax>(m, "DefaultSkewItemSyntax")
        .def_readwrite("keyword", &DefaultSkewItemSyntax::keyword)
        .def_readwrite("direction", &DefaultSkewItemSyntax::direction)
        .def_readwrite("semi", &DefaultSkewItemSyntax::semi);

    py::class_<ClockingItemSyntax, MemberSyntax>(m, "ClockingItemSyntax")
        .def_readwrite("direction", &ClockingItemSyntax::direction)
        .def_readwrite("decls", &ClockingItemSyntax::decls)
        .def_readwrite("semi", &ClockingItemSyntax::semi);

    py::class_<ClockingDeclarationSyntax, MemberSyntax>(m, "ClockingDeclarationSyntax")
        .def_readwrite("globalOrDefault", &ClockingDeclarationSyntax::globalOrDefault)
        .def_readwrite("clocking", &ClockingDeclarationSyntax::clocking)
        .def_readwrite("blockName", &ClockingDeclarationSyntax::blockName)
        .def_readwrite("at", &ClockingDeclarationSyntax::at)
        .def_readwrite("event", &ClockingDeclarationSyntax::event)
        .def_readwrite("semi", &ClockingDeclarationSyntax::semi)
        .def_readwrite("items", &ClockingDeclarationSyntax::items)
        .def_readwrite("endClocking", &ClockingDeclarationSyntax::endClocking)
        .def_readwrite("endBlockName", &ClockingDeclarationSyntax::endBlockName);

    py::class_<DefaultClockingReferenceSyntax, MemberSyntax>(m, "DefaultClockingReferenceSyntax")
        .def_readwrite("defaultKeyword", &DefaultClockingReferenceSyntax::defaultKeyword)
        .def_readwrite("clocking", &DefaultClockingReferenceSyntax::clocking)
        .def_readwrite("name", &DefaultClockingReferenceSyntax::name)
        .def_readwrite("semi", &DefaultClockingReferenceSyntax::semi);

    py::class_<DefaultDisableDeclarationSyntax, MemberSyntax>(m, "DefaultDisableDeclarationSyntax")
        .def_readwrite("defaultKeyword", &DefaultDisableDeclarationSyntax::defaultKeyword)
        .def_readwrite("disableKeyword", &DefaultDisableDeclarationSyntax::disableKeyword)
        .def_readwrite("iffKeyword", &DefaultDisableDeclarationSyntax::iffKeyword)
        .def_readwrite("expr", &DefaultDisableDeclarationSyntax::expr)
        .def_readwrite("semi", &DefaultDisableDeclarationSyntax::semi);

    py::class_<DPIImportSyntax, MemberSyntax>(m, "DPIImportSyntax")
        .def_readwrite("keyword", &DPIImportSyntax::keyword)
        .def_readwrite("specString", &DPIImportSyntax::specString)
        .def_readwrite("property", &DPIImportSyntax::property)
        .def_readwrite("c_identifier", &DPIImportSyntax::c_identifier)
        .def_readwrite("equals", &DPIImportSyntax::equals)
        .def_readwrite("method", &DPIImportSyntax::method)
        .def_readwrite("semi", &DPIImportSyntax::semi);

    py::class_<DPIExportSyntax, MemberSyntax>(m, "DPIExportSyntax")
        .def_readwrite("keyword", &DPIExportSyntax::keyword)
        .def_readwrite("specString", &DPIExportSyntax::specString)
        .def_readwrite("c_identifier", &DPIExportSyntax::c_identifier)
        .def_readwrite("equals", &DPIExportSyntax::equals)
        .def_readwrite("functionOrTask", &DPIExportSyntax::functionOrTask)
        .def_readwrite("name", &DPIExportSyntax::name)
        .def_readwrite("semi", &DPIExportSyntax::semi);

    py::class_<ElabSystemTaskSyntax, MemberSyntax>(m, "ElabSystemTaskSyntax")
        .def_readwrite("name", &ElabSystemTaskSyntax::name)
        .def_readwrite("arguments", &ElabSystemTaskSyntax::arguments)
        .def_readwrite("semi", &ElabSystemTaskSyntax::semi);

    py::class_<UdpPortDeclSyntax, SyntaxNode>(m, "UdpPortDeclSyntax")
        .def_readwrite("attributes", &UdpPortDeclSyntax::attributes);

    py::class_<UdpOutputPortDeclSyntax, UdpPortDeclSyntax>(m, "UdpOutputPortDeclSyntax")
        .def_readwrite("keyword", &UdpOutputPortDeclSyntax::keyword)
        .def_readwrite("reg", &UdpOutputPortDeclSyntax::reg)
        .def_readwrite("name", &UdpOutputPortDeclSyntax::name)
        .def_readwrite("initializer", &UdpOutputPortDeclSyntax::initializer);

    py::class_<UdpInputPortDeclSyntax, UdpPortDeclSyntax>(m, "UdpInputPortDeclSyntax")
        .def_readwrite("keyword", &UdpInputPortDeclSyntax::keyword)
        .def_readwrite("names", &UdpInputPortDeclSyntax::names);

    py::class_<UdpPortListSyntax, SyntaxNode>(m, "UdpPortListSyntax");

    py::class_<AnsiUdpPortListSyntax, UdpPortListSyntax>(m, "AnsiUdpPortListSyntax")
        .def_readwrite("openParen", &AnsiUdpPortListSyntax::openParen)
        .def_readwrite("ports", &AnsiUdpPortListSyntax::ports)
        .def_readwrite("closeParen", &AnsiUdpPortListSyntax::closeParen)
        .def_readwrite("semi", &AnsiUdpPortListSyntax::semi);

    py::class_<NonAnsiUdpPortListSyntax, UdpPortListSyntax>(m, "NonAnsiUdpPortListSyntax")
        .def_readwrite("openParen", &NonAnsiUdpPortListSyntax::openParen)
        .def_readwrite("ports", &NonAnsiUdpPortListSyntax::ports)
        .def_readwrite("closeParen", &NonAnsiUdpPortListSyntax::closeParen)
        .def_readwrite("semi", &NonAnsiUdpPortListSyntax::semi);

    py::class_<WildcardUdpPortListSyntax, UdpPortListSyntax>(m, "WildcardUdpPortListSyntax")
        .def_readwrite("openParen", &WildcardUdpPortListSyntax::openParen)
        .def_readwrite("dot", &WildcardUdpPortListSyntax::dot)
        .def_readwrite("star", &WildcardUdpPortListSyntax::star)
        .def_readwrite("closeParen", &WildcardUdpPortListSyntax::closeParen)
        .def_readwrite("semi", &WildcardUdpPortListSyntax::semi);

    py::class_<UdpInitialStmtSyntax, SyntaxNode>(m, "UdpInitialStmtSyntax")
        .def_readwrite("initial", &UdpInitialStmtSyntax::initial)
        .def_readwrite("name", &UdpInitialStmtSyntax::name)
        .def_readwrite("equals", &UdpInitialStmtSyntax::equals)
        .def_readwrite("value", &UdpInitialStmtSyntax::value)
        .def_readwrite("semi", &UdpInitialStmtSyntax::semi);

    py::class_<UdpFieldBaseSyntax, SyntaxNode>(m, "UdpFieldBaseSyntax");

    py::class_<UdpEdgeFieldSyntax, UdpFieldBaseSyntax>(m, "UdpEdgeFieldSyntax")
        .def_readwrite("openParen", &UdpEdgeFieldSyntax::openParen)
        .def_readwrite("first", &UdpEdgeFieldSyntax::first)
        .def_readwrite("second", &UdpEdgeFieldSyntax::second)
        .def_readwrite("closeParen", &UdpEdgeFieldSyntax::closeParen);

    py::class_<UdpSimpleFieldSyntax, UdpFieldBaseSyntax>(m, "UdpSimpleFieldSyntax")
        .def_readwrite("field", &UdpSimpleFieldSyntax::field);

    py::class_<UdpEntrySyntax, SyntaxNode>(m, "UdpEntrySyntax")
        .def_readwrite("inputs", &UdpEntrySyntax::inputs)
        .def_readwrite("colon1", &UdpEntrySyntax::colon1)
        .def_readwrite("current", &UdpEntrySyntax::current)
        .def_readwrite("colon2", &UdpEntrySyntax::colon2)
        .def_readwrite("next", &UdpEntrySyntax::next)
        .def_readwrite("semi", &UdpEntrySyntax::semi);

    py::class_<UdpBodySyntax, SyntaxNode>(m, "UdpBodySyntax")
        .def_readwrite("portDecls", &UdpBodySyntax::portDecls)
        .def_readwrite("initialStmt", &UdpBodySyntax::initialStmt)
        .def_readwrite("table", &UdpBodySyntax::table)
        .def_readwrite("entries", &UdpBodySyntax::entries)
        .def_readwrite("endtable", &UdpBodySyntax::endtable);

    py::class_<UdpDeclarationSyntax, MemberSyntax>(m, "UdpDeclarationSyntax")
        .def_readwrite("primitive", &UdpDeclarationSyntax::primitive)
        .def_readwrite("name", &UdpDeclarationSyntax::name)
        .def_readwrite("portList", &UdpDeclarationSyntax::portList)
        .def_readwrite("body", &UdpDeclarationSyntax::body)
        .def_readwrite("endprimitive", &UdpDeclarationSyntax::endprimitive)
        .def_readwrite("endBlockName", &UdpDeclarationSyntax::endBlockName);

    py::class_<SpecparamDeclaratorSyntax, SyntaxNode>(m, "SpecparamDeclaratorSyntax")
        .def_readwrite("name", &SpecparamDeclaratorSyntax::name)
        .def_readwrite("equals", &SpecparamDeclaratorSyntax::equals)
        .def_readwrite("openParen", &SpecparamDeclaratorSyntax::openParen)
        .def_readwrite("value1", &SpecparamDeclaratorSyntax::value1)
        .def_readwrite("comma", &SpecparamDeclaratorSyntax::comma)
        .def_readwrite("value2", &SpecparamDeclaratorSyntax::value2)
        .def_readwrite("closeParen", &SpecparamDeclaratorSyntax::closeParen);

    py::class_<SpecparamDeclarationSyntax, MemberSyntax>(m, "SpecparamDeclarationSyntax")
        .def_readwrite("keyword", &SpecparamDeclarationSyntax::keyword)
        .def_readwrite("type", &SpecparamDeclarationSyntax::type)
        .def_readwrite("declarators", &SpecparamDeclarationSyntax::declarators)
        .def_readwrite("semi", &SpecparamDeclarationSyntax::semi);

    py::class_<PathSuffixSyntax, SyntaxNode>(m, "PathSuffixSyntax");

    py::class_<SimplePathSuffixSyntax, PathSuffixSyntax>(m, "SimplePathSuffixSyntax")
        .def_readwrite("outputs", &SimplePathSuffixSyntax::outputs);

    py::class_<EdgeSensitivePathSuffixSyntax, PathSuffixSyntax>(m, "EdgeSensitivePathSuffixSyntax")
        .def_readwrite("openParen", &EdgeSensitivePathSuffixSyntax::openParen)
        .def_readwrite("outputs", &EdgeSensitivePathSuffixSyntax::outputs)
        .def_readwrite("polarityOperator", &EdgeSensitivePathSuffixSyntax::polarityOperator)
        .def_readwrite("colon", &EdgeSensitivePathSuffixSyntax::colon)
        .def_readwrite("expr", &EdgeSensitivePathSuffixSyntax::expr)
        .def_readwrite("closeParen", &EdgeSensitivePathSuffixSyntax::closeParen);

    py::class_<PathDescriptionSyntax, SyntaxNode>(m, "PathDescriptionSyntax")
        .def_readwrite("openParen", &PathDescriptionSyntax::openParen)
        .def_readwrite("edgeIdentifier", &PathDescriptionSyntax::edgeIdentifier)
        .def_readwrite("inputs", &PathDescriptionSyntax::inputs)
        .def_readwrite("polarityOperator", &PathDescriptionSyntax::polarityOperator)
        .def_readwrite("pathOperator", &PathDescriptionSyntax::pathOperator)
        .def_readwrite("suffix", &PathDescriptionSyntax::suffix)
        .def_readwrite("closeParen", &PathDescriptionSyntax::closeParen);

    py::class_<PathDeclarationSyntax, MemberSyntax>(m, "PathDeclarationSyntax")
        .def_readwrite("desc", &PathDeclarationSyntax::desc)
        .def_readwrite("equals", &PathDeclarationSyntax::equals)
        .def_readwrite("openParen", &PathDeclarationSyntax::openParen)
        .def_readwrite("delays", &PathDeclarationSyntax::delays)
        .def_readwrite("closeParen", &PathDeclarationSyntax::closeParen)
        .def_readwrite("semi", &PathDeclarationSyntax::semi);

    py::class_<ConditionalPathDeclarationSyntax, MemberSyntax>(m, "ConditionalPathDeclarationSyntax")
        .def_readwrite("keyword", &ConditionalPathDeclarationSyntax::keyword)
        .def_readwrite("openParen", &ConditionalPathDeclarationSyntax::openParen)
        .def_readwrite("predicate", &ConditionalPathDeclarationSyntax::predicate)
        .def_readwrite("closeParen", &ConditionalPathDeclarationSyntax::closeParen)
        .def_readwrite("path", &ConditionalPathDeclarationSyntax::path);

    py::class_<IfNonePathDeclarationSyntax, MemberSyntax>(m, "IfNonePathDeclarationSyntax")
        .def_readwrite("keyword", &IfNonePathDeclarationSyntax::keyword)
        .def_readwrite("path", &IfNonePathDeclarationSyntax::path);

    py::class_<PulseStyleDeclarationSyntax, MemberSyntax>(m, "PulseStyleDeclarationSyntax")
        .def_readwrite("keyword", &PulseStyleDeclarationSyntax::keyword)
        .def_readwrite("inputs", &PulseStyleDeclarationSyntax::inputs)
        .def_readwrite("semi", &PulseStyleDeclarationSyntax::semi);

    py::class_<TimingCheckArgSyntax, SyntaxNode>(m, "TimingCheckArgSyntax");

    py::class_<EmptyTimingCheckArgSyntax, TimingCheckArgSyntax>(m, "EmptyTimingCheckArgSyntax")
        .def_readwrite("placeholder", &EmptyTimingCheckArgSyntax::placeholder);

    py::class_<EdgeDescriptorSyntax, SyntaxNode>(m, "EdgeDescriptorSyntax")
        .def_readwrite("t1", &EdgeDescriptorSyntax::t1)
        .def_readwrite("t2", &EdgeDescriptorSyntax::t2);

    py::class_<EdgeControlSpecifierSyntax, SyntaxNode>(m, "EdgeControlSpecifierSyntax")
        .def_readwrite("openBracket", &EdgeControlSpecifierSyntax::openBracket)
        .def_readwrite("descriptors", &EdgeControlSpecifierSyntax::descriptors)
        .def_readwrite("closeBracket", &EdgeControlSpecifierSyntax::closeBracket);

    py::class_<TimingCheckEventConditionSyntax, SyntaxNode>(m, "TimingCheckEventConditionSyntax")
        .def_readwrite("tripleAnd", &TimingCheckEventConditionSyntax::tripleAnd)
        .def_readwrite("expr", &TimingCheckEventConditionSyntax::expr);

    py::class_<TimingCheckEventArgSyntax, TimingCheckArgSyntax>(m, "TimingCheckEventArgSyntax")
        .def_readwrite("edge", &TimingCheckEventArgSyntax::edge)
        .def_readwrite("controlSpecifier", &TimingCheckEventArgSyntax::controlSpecifier)
        .def_readwrite("terminal", &TimingCheckEventArgSyntax::terminal)
        .def_readwrite("condition", &TimingCheckEventArgSyntax::condition);

    py::class_<ExpressionTimingCheckArgSyntax, TimingCheckArgSyntax>(m, "ExpressionTimingCheckArgSyntax")
        .def_readwrite("expr", &ExpressionTimingCheckArgSyntax::expr);

    py::class_<SystemTimingCheckSyntax, MemberSyntax>(m, "SystemTimingCheckSyntax")
        .def_readwrite("name", &SystemTimingCheckSyntax::name)
        .def_readwrite("openParen", &SystemTimingCheckSyntax::openParen)
        .def_readwrite("args", &SystemTimingCheckSyntax::args)
        .def_readwrite("closeParen", &SystemTimingCheckSyntax::closeParen)
        .def_readwrite("semi", &SystemTimingCheckSyntax::semi);

    py::class_<SpecifyBlockSyntax, MemberSyntax>(m, "SpecifyBlockSyntax")
        .def_readwrite("specify", &SpecifyBlockSyntax::specify)
        .def_readwrite("items", &SpecifyBlockSyntax::items)
        .def_readwrite("endspecify", &SpecifyBlockSyntax::endspecify);

    py::class_<NetAliasSyntax, MemberSyntax>(m, "NetAliasSyntax")
        .def_readwrite("keyword", &NetAliasSyntax::keyword)
        .def_readwrite("nets", &NetAliasSyntax::nets)
        .def_readwrite("semi", &NetAliasSyntax::semi);

    py::class_<ExternModuleDeclSyntax, MemberSyntax>(m, "ExternModuleDeclSyntax")
        .def_readwrite("externKeyword", &ExternModuleDeclSyntax::externKeyword)
        .def_readwrite("actualAttributes", &ExternModuleDeclSyntax::actualAttributes)
        .def_readwrite("header", &ExternModuleDeclSyntax::header);

    py::class_<ExternUdpDeclSyntax, MemberSyntax>(m, "ExternUdpDeclSyntax")
        .def_readwrite("externKeyword", &ExternUdpDeclSyntax::externKeyword)
        .def_readwrite("actualAttributes", &ExternUdpDeclSyntax::actualAttributes)
        .def_readwrite("primitive", &ExternUdpDeclSyntax::primitive)
        .def_readwrite("name", &ExternUdpDeclSyntax::name)
        .def_readwrite("portList", &ExternUdpDeclSyntax::portList);

    py::class_<ExternInterfaceMethodSyntax, MemberSyntax>(m, "ExternInterfaceMethodSyntax")
        .def_readwrite("externKeyword", &ExternInterfaceMethodSyntax::externKeyword)
        .def_readwrite("forkJoin", &ExternInterfaceMethodSyntax::forkJoin)
        .def_readwrite("prototype", &ExternInterfaceMethodSyntax::prototype)
        .def_readwrite("semi", &ExternInterfaceMethodSyntax::semi);

    py::class_<ConstraintItemSyntax, SyntaxNode>(m, "ConstraintItemSyntax");

    py::class_<DistWeightSyntax, SyntaxNode>(m, "DistWeightSyntax")
        .def_readwrite("op", &DistWeightSyntax::op)
        .def_readwrite("extraOp", &DistWeightSyntax::extraOp)
        .def_readwrite("expr", &DistWeightSyntax::expr);

    py::class_<DistItemBaseSyntax, SyntaxNode>(m, "DistItemBaseSyntax");

    py::class_<DistItemSyntax, DistItemBaseSyntax>(m, "DistItemSyntax")
        .def_readwrite("range", &DistItemSyntax::range)
        .def_readwrite("weight", &DistItemSyntax::weight);

    py::class_<DefaultDistItemSyntax, DistItemBaseSyntax>(m, "DefaultDistItemSyntax")
        .def_readwrite("defaultKeyword", &DefaultDistItemSyntax::defaultKeyword)
        .def_readwrite("weight", &DefaultDistItemSyntax::weight);

    py::class_<DistConstraintListSyntax, SyntaxNode>(m, "DistConstraintListSyntax")
        .def_readwrite("dist", &DistConstraintListSyntax::dist)
        .def_readwrite("openBrace", &DistConstraintListSyntax::openBrace)
        .def_readwrite("items", &DistConstraintListSyntax::items)
        .def_readwrite("closeBrace", &DistConstraintListSyntax::closeBrace);

    py::class_<ExpressionOrDistSyntax, ExpressionSyntax>(m, "ExpressionOrDistSyntax")
        .def_readwrite("expr", &ExpressionOrDistSyntax::expr)
        .def_readwrite("distribution", &ExpressionOrDistSyntax::distribution);

    py::class_<ExpressionConstraintSyntax, ConstraintItemSyntax>(m, "ExpressionConstraintSyntax")
        .def_readwrite("soft", &ExpressionConstraintSyntax::soft)
        .def_readwrite("expr", &ExpressionConstraintSyntax::expr)
        .def_readwrite("semi", &ExpressionConstraintSyntax::semi);

    py::class_<UniquenessConstraintSyntax, ConstraintItemSyntax>(m, "UniquenessConstraintSyntax")
        .def_readwrite("unique", &UniquenessConstraintSyntax::unique)
        .def_readwrite("ranges", &UniquenessConstraintSyntax::ranges)
        .def_readwrite("semi", &UniquenessConstraintSyntax::semi);

    py::class_<ImplicationConstraintSyntax, ConstraintItemSyntax>(m, "ImplicationConstraintSyntax")
        .def_readwrite("left", &ImplicationConstraintSyntax::left)
        .def_readwrite("arrow", &ImplicationConstraintSyntax::arrow)
        .def_readwrite("constraints", &ImplicationConstraintSyntax::constraints);

    py::class_<ElseConstraintClauseSyntax, SyntaxNode>(m, "ElseConstraintClauseSyntax")
        .def_readwrite("elseKeyword", &ElseConstraintClauseSyntax::elseKeyword)
        .def_readwrite("constraints", &ElseConstraintClauseSyntax::constraints);

    py::class_<ConditionalConstraintSyntax, ConstraintItemSyntax>(m, "ConditionalConstraintSyntax")
        .def_readwrite("ifKeyword", &ConditionalConstraintSyntax::ifKeyword)
        .def_readwrite("openParen", &ConditionalConstraintSyntax::openParen)
        .def_readwrite("condition", &ConditionalConstraintSyntax::condition)
        .def_readwrite("closeParen", &ConditionalConstraintSyntax::closeParen)
        .def_readwrite("constraints", &ConditionalConstraintSyntax::constraints)
        .def_readwrite("elseClause", &ConditionalConstraintSyntax::elseClause);

    py::class_<LoopConstraintSyntax, ConstraintItemSyntax>(m, "LoopConstraintSyntax")
        .def_readwrite("foreachKeyword", &LoopConstraintSyntax::foreachKeyword)
        .def_readwrite("loopList", &LoopConstraintSyntax::loopList)
        .def_readwrite("constraints", &LoopConstraintSyntax::constraints);

    py::class_<DisableConstraintSyntax, ConstraintItemSyntax>(m, "DisableConstraintSyntax")
        .def_readwrite("disable", &DisableConstraintSyntax::disable)
        .def_readwrite("soft", &DisableConstraintSyntax::soft)
        .def_readwrite("name", &DisableConstraintSyntax::name)
        .def_readwrite("semi", &DisableConstraintSyntax::semi);

    py::class_<SolveBeforeConstraintSyntax, ConstraintItemSyntax>(m, "SolveBeforeConstraintSyntax")
        .def_readwrite("solve", &SolveBeforeConstraintSyntax::solve)
        .def_readwrite("beforeExpr", &SolveBeforeConstraintSyntax::beforeExpr)
        .def_readwrite("before", &SolveBeforeConstraintSyntax::before)
        .def_readwrite("afterExpr", &SolveBeforeConstraintSyntax::afterExpr)
        .def_readwrite("semi", &SolveBeforeConstraintSyntax::semi);

    py::class_<ConstraintBlockSyntax, ConstraintItemSyntax>(m, "ConstraintBlockSyntax")
        .def_readwrite("openBrace", &ConstraintBlockSyntax::openBrace)
        .def_readwrite("items", &ConstraintBlockSyntax::items)
        .def_readwrite("closeBrace", &ConstraintBlockSyntax::closeBrace);

    py::class_<ConstraintPrototypeSyntax, MemberSyntax>(m, "ConstraintPrototypeSyntax")
        .def_readwrite("qualifiers", &ConstraintPrototypeSyntax::qualifiers)
        .def_readwrite("keyword", &ConstraintPrototypeSyntax::keyword)
        .def_readwrite("specifiers", &ConstraintPrototypeSyntax::specifiers)
        .def_readwrite("name", &ConstraintPrototypeSyntax::name)
        .def_readwrite("semi", &ConstraintPrototypeSyntax::semi);

}
